using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using enemy;
//G𐶐肷
public class EnemyManager : MonoBehaviour
{
    public List<Enemy> enemys;
    public GameObject enemyPrefav;

    public Material m1;
    public Material m2;
    public Material m3;

    public float jikineInterMin = 0.6f;
    public float jikineBulletSpeMin = 4;

    public float uzuInterMin = 0.2f;
    public float uzuBulletSpeMin=6;
    public int uzuArmNumMin = 4;
    public float uzuRotationMin=60;

    public float radialInterMin =1;
    public float radialBulletSpeMin =4;
    public int radialArmNumMin = 7;


    // Start is called before the first frame update
    void Start()
    {
        enemys = new List<Enemy>();
    }

    // Update is called once per frame
    void Update()
    {
        
    }
    public void AddEnemy()
    {
        var r = Random.value * 100.0f;
        if(r<40)//40%
        {
            //enemy1 @_
            var e = Instantiate(enemyPrefav).AddComponent<Enemy1>();
            e.GetComponent<Renderer>().material = m1;
            e.intervalTime = jikineInterMin*Random.Range(1.0f,2.0f);
            e.bulletSpeed = jikineBulletSpeMin * Random.Range(1.0f, 2.0f);
            enemys.Add(e);
        }
        else if(r<60)//20%
        {
            //
            var e = Instantiate(enemyPrefav).AddComponent<Enemy2>();
            e.GetComponent<Renderer>().material = m2;
            e.Initialized(
                            ArmNum: (int)(uzuArmNumMin * Random.Range(1.0f, 2.0f)),
                            rotationSpeed: uzuRotationMin * Random.Range(1.0f, 2.0f),
                            bulletSpeed: uzuBulletSpeMin * Random.Range(1.0f, 2.0f),
                            interval: uzuInterMin * Random.Range(1.0f, 2.0f)
                            );
            enemys.Add(e);
        }
        else if(r<75)//15%
        {
            //
            var e = Instantiate(enemyPrefav).AddComponent<Enemy3>();
            e.GetComponent<Renderer>().material = m3;
            e.Initialized(
                ArmNum: (int)(radialArmNumMin * Random.Range(1.0f, 2.0f)),
                bulletSpeed: radialBulletSpeMin * Random.Range(1.0f, 2.0f),
                interval: radialInterMin * Random.Range(1.0f, 2.0f));
            enemys.Add(e);
            
        }
        else if(r<87.5)//12.5%
        {
            //@
            var e = Instantiate(enemyPrefav).AddComponent<Enemy2>();
            e.GetComponent<Renderer>().material = m2;
            e.Initialized(
                ArmNum: (int)(uzuArmNumMin * Random.Range(1.0f, 2.0f)),
                rotationSpeed: uzuRotationMin * Random.Range(1.0f, 2.0f),
                bulletSpeed: uzuBulletSpeMin * Random.Range(1.0f, 2.0f),
                interval: uzuInterMin * Random.Range(1.0f, 2.0f)
                );
            var oi = e.gameObject.AddComponent<Oikake>();
            oi.g = 9;
            enemys.Add(e);
        }
        else if(r<=100)//12.5%
        {
            //@
            var e = Instantiate(enemyPrefav).AddComponent<Enemy3>();
            e.Initialized(
                            ArmNum: (int)(radialArmNumMin * Random.Range(1.0f, 2.0f)),
                            bulletSpeed: radialBulletSpeMin * Random.Range(1.0f, 2.0f),
                            interval: radialInterMin * Random.Range(1.0f, 2.0f));
            e.GetComponent<Renderer>().material = m3;
            var oi = e.gameObject.AddComponent<Oikake>();
            oi.g = 9;
            enemys.Add(e);
        }
    }
}
