using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using enemy;
using System;

public class GameMaster : MonoBehaviour
{
    public player player;
    public EnemyManager em;
    public GameObject CbItem;
    private SceneFadeManager fader;
    public static float score = 0;
    public float enemyGenerationTime = 3;
    private float generationTimer;

    public float cbItemGenerationTime = 0;
    private float cbItemGenerationTimer = 0;

    // Start is called before the first frame update
    void Start()
    {
        em = GameObject.Find("EnemyManager").GetComponent<EnemyManager>();
        player = GameObject.Find("Player").GetComponent<player>();
        player.OnPlayerDeth.AddListener(GoToResultScene);
        fader = GameObject.Find("Fader").GetComponent<SceneFadeManager>();
        score = 0;
        generationTimer = enemyGenerationTime - 3;
        cbItemGenerationTimer -= 3;
        GameObject.Find("BulletManager").GetComponent<BulletManager>().OnClear.AddListener(ResetEnemy);
    }

    // Update is called once per frame
    void Update()
    {
        if (enemyGenerationTime <= 0)
            throw new Exception("G̐Ԃ0傫Ă enemyGenerationTime:" + enemyGenerationTime.ToString());

        generationTimer += Time.deltaTime;
        while(generationTimer > enemyGenerationTime)
        {
            em.AddEnemy();
            
            generationTimer -= enemyGenerationTime;
        }
        
        cbItemGenerationTimer += Time.deltaTime;
        while (cbItemGenerationTimer > cbItemGenerationTime)
        {
            Instantiate(CbItem);

            cbItemGenerationTimer -= cbItemGenerationTime;
        }
    }

    // UgV[֑Jڂ郁\bh
    public void GoToResultScene()
    {
        fader.fadeOutStart(0, 0, 0, 0, "Result");
    }
    
    private void ResetEnemy()
    {
        foreach(var ene in em.enemys)
        {
            if(ene!=null)
            {
                ene.ResetEnemy();
            }
        }
    }
}
