
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class SceneFadeManager : MonoBehaviour
{
    //tF[hAEg̊JnAǗtO
    private bool isFadeOut = false;
    //tF[hC̊JnAǗtO
    private bool isFadeIn = true;
    //xςXs[h
    float fadeSpeed = 0.75f;
    //ʂtF[h邽߂̉摜pubNŎ擾
    public Image fadeImage;
    float red, green, blue, alfa;
    //V[Jڂ̂߂̌^
    string afterScene;
    // Start is called before the first frame update
    void Start()
    {
        DontDestroyOnLoad(this);
        SetRGBA(0, 0, 0, 1);
        //V[JڂۂɃtF[hCJn悤ɐݒ
        SceneManager.sceneLoaded += fadeInStart;
    }
    //V[JڂۂɃtF[hCJn悤ɐݒ
    void fadeInStart(Scene scene, LoadSceneMode mode)
    {
        isFadeIn = true;
    }
    /// <summary>
    /// tF[hAEgJn̉摜RGBAlƎ̃V[w
    /// </summary>
    /// <param name="red">摜̐Ԑ</param>
    /// <param name="green">摜̗ΐ</param>
    /// <param name="blue">摜̐</param>
    /// <param name="alfa">摜̓x</param>
    /// <param name="nextScene">Jڐ̃V[</param>
    public void fadeOutStart(int red, int green, int blue, int alfa, string nextScene)
    {
        SetRGBA(red, green, blue, alfa);
        SetColor();
        isFadeOut = true;
        afterScene = nextScene;
    }
    // Update is called once per frame
    void Update()
    {
        if (isFadeIn == true)
        {
            //sxXɉ
            alfa -= fadeSpeed * Time.deltaTime;
            //ύXx摜ɔf֐Ă
            SetColor();
            if (alfa <= 0)
                isFadeIn = false;
        }
        if (isFadeOut == true)
        {
            //sxXɏグ
            alfa += fadeSpeed * Time.deltaTime;
            //ύXx摜ɔf֐Ă
            SetColor();
            if (alfa >= 1)
            {
                isFadeOut = false;
                SceneManager.LoadScene(afterScene);
            }
        }
    }
    //摜ɐF֐
    void SetColor()
    {
        if (fadeImage != null) fadeImage.color = new Color(red, green, blue, alfa);
    }
    //F̒lݒ肷邽߂̊֐
    public void SetRGBA(int r, int g, int b, int a)
    {
        red = r;
        green = g;
        blue = b;
        alfa = a;
    }
}
