using System.Collections;
using System.Collections.Generic;
using System.Xml.Schema;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SocialPlatforms.Impl;

public class player : MonoBehaviour
{
    public float scale = 1;
    private BulletManager bm;
    private SphereCollider sc;
    private Renderer mate;
    private Transform ufo;
    public float w = 30;
    public UnityEvent OnPlayerDeth;
    private bool deth = false;
    private float t = 0;
    private float tt = 0.5f;

    // Start is called before the first frame update
    void Start()
    {
        ufo = transform.GetChild(0);
        var offset = ufo.GetComponent<MeshFilter>().mesh.bounds.center;
        ufo.localScale=new Vector3(scale,scale,scale);
        ufo.position = -offset * scale;
        ufo.RotateAround(transform.position, Vector3.right, -90);

        bm = GameObject.Find("BulletManager").GetComponent<BulletManager>();
        sc=GetComponent<SphereCollider>();

        mate= ufo.GetComponent<Renderer>();
    }

    // Update is called once per frame
    void Update()
    {
        if (deth)
        {
            t += Time.deltaTime;
            mate.material.color = new Color(1, 1, 1, Mathf.Max(1 - t / tt, 0f));
            if (t > tt && t < tt * 2)
            {
                t = tt * 3;
                OnPlayerDeth.Invoke();
            }
            return;
        }

        GameMaster.score += Time.deltaTime * 20;

        Mawasu();

        var dir = new Vector3(0, 0, 0);
        if (Input.GetKey(KeyCode.LeftArrow)) dir += Vector3.left;
        if (Input.GetKey(KeyCode.RightArrow)) dir += Vector3.right;
        if (Input.GetKey(KeyCode.UpArrow)) dir += Vector3.up;
        if (Input.GetKey(KeyCode.DownArrow)) dir += Vector3.down;
        dir.Normalize();

        if (!  Input.GetKey(KeyCode.LeftShift)) dir *= 9f;
        else dir *= 4.5f;

        var dt = Time.deltaTime;

        if (IsOutsideViewport(transform.position + new Vector3(dir.x * dt, 0, 0))) dir.x = 0;
        if (IsOutsideViewport(transform.position + new Vector3(0, dir.y * dt, 0))) dir.y = 0;

        if (dir.sqrMagnitude > 0) transform.position += dir*Time.deltaTime;

        if (IsHited(sc.radius))
        {
            deth = true;
        }
    }
    private bool IsOutsideViewport(Vector3 position)
    {
        Vector3 viewportPosition = Camera.main.WorldToViewportPoint(position);
        return viewportPosition.x < 0 || viewportPosition.x > 1 || viewportPosition.y < 0 || viewportPosition.y > 1;
    }
    private bool IsHited(float colR)
    {
        var bullets=bm.GetBullets();

        foreach(var bullet in bullets)
        {
            if(bullet==null) continue;
            //aœ蔻
            if ((transform.position - bullet.transform.position).sqrMagnitude < colR * colR) return true;
        }
        return false;
    }

    private void Mawasu()
    {
        ufo.RotateAround(transform.position, Vector3.right, w * Mathf.Sin(Time.time * Mathf.PI * 2) * Time.deltaTime);
        ufo.RotateAround(transform.position, Vector3.forward, w * Mathf.Cos(Time.time * Mathf.PI * 2) * Time.deltaTime);
    }
}
