using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using enemy;
using UnityEngine.Events;

public class BulletManager : MonoBehaviour
{
    private List<Bullet> bullets;
    public GameObject bulletPrefav;
    public UnityEvent OnClear;
    
    // Start is called before the first frame update
    void Start()
    {
        bullets = new List<Bullet>();
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public void Add(Vector3 pos, float velX, float velY)
    {
        var b = Instantiate(bulletPrefav).AddComponent<Bullet>();
        b.Initialize(pos, new Vector3(velX, velY, 0));
        bullets.Add(b);
    }

    public void Remove(Bullet bullet)
    {
        bullets.Remove(bullet);
    }

    public void Clear() {
        int count = 0;
        foreach (var b in bullets)
        {
            if (b != null)
            {
                Destroy(b.gameObject);
                count++;
            }
        }

        OnClear.Invoke();

        GameMaster.score += count * 100;



        bullets.Clear();
    }

    public List<Bullet> GetBullets() { return bullets; }
}
