using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TitleManager : MonoBehaviour
{
    private SceneFadeManager fader;
    bool pushed = false;
    // Start is called before the first frame update
    void Start()
    {
        fader = GetComponent<SceneFadeManager>();

        if (Screen.fullScreen)
        {
            Screen.SetResolution(
                Screen.width,
                Screen.height,
                Screen.fullScreen);
        }
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public void OnStartButtonPushed()
    {
        if (!pushed)
        {
            fader.fadeOutStart(0, 0, 0, 0, "SampleScene");
            pushed = true;
        }
    }
}
